import { Component, TSX } from "../TSX/TSX";
import { BasicComponent } from "./BasicComponent";
export declare abstract class Fragment<T> extends BasicComponent<T & {
    fragmentList: Fragment.List<Fragment<T>>;
}> {
    private rendered;
    remove(): void;
    moveTo(pos: number): void;
    moveUp(): void;
    moveDown(): void;
    onDetached(): void;
    static attachRendered<K extends Fragment<any>>(instance: K, rendered: TSX.RenderedComponent<K>): void;
}
export declare namespace Fragment {
    class List<T extends Fragment<any>> {
        private fragments;
        private component;
        get count(): number;
        addFragment(FragmentClass: new () => T, args: Omit<TSX.Props<T>, "fragmentList">, at?: number): T;
        moveFragment(rendered: TSX.RenderedComponent<T>, to?: number): T;
        removeFragment(rendered: TSX.RenderedComponent<T>): boolean;
        indexOf(rendered: TSX.RenderedComponent<T>): number;
        static attachComponent<T extends Fragment<any>>(list: List<T>, component: Container<T>): void;
    }
    namespace Container {
        interface Props<T extends Fragment<any>> extends JSX.HTMLAttributes<HTMLDivElement> {
            fragmentList: List<T>;
            [Component.Children]?: undefined;
        }
    }
    class Container<T extends Fragment<any>> extends BasicComponent<Container.Props<T>> {
        private container;
        attachContainer(instance: HTMLDivElement): void;
        attachFragment(rendered: TSX.RenderedComponent<T>, at?: number | Node): void;
        render(): JSX.Element;
    }
}
